(** Simple functional queues *)

type +'a t

val empty : 'a t

val push      : 'a t -> 'a -> 'a t
val push_list : 'a t -> 'a list -> 'a t
val concat    : 'a t -> 'a t -> 'a t
val to_list   : 'a t -> 'a list

val list_fold : ('a t -> 'b -> 'a t) -> 'b list -> 'a list
